#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>  // Para open/read/write en windows
//#include <unistd.h> // Para open/read/write en unix
#include <string.h>
int main(int argc, char *argv[]) 
{
  int f_texto; // Ahora los ficheros son "int" !
  int f_data;
  int x=10;
  int y=47;
  float g=1.0;
  char txt[5]="Hola"; // 5 = 4 letras mas terminador
  char linea[80]; // Para convertir los datos a ASCII

  if (argc<2) { // No hay argumento, modo "crear ficheros"
    f_texto=open("Datos.txt", O_WRONLY|O_CREAT|O_TEXT, S_IWRITE);
    if (f_texto==-1) {
      perror("Creando Datos.txt"); exit(-1);
    }
    
    f_data=open("Datos.dat", O_WRONLY|O_CREAT|O_BINARY, S_IWRITE);
    if (f_data==-1) {
      perror("Creando Datos.dat"); exit(-1);
    }
    
    // Escribimos los datos como ASCII en Datos.txt
    // sprintf lo convierte en cadena de texto, y write lo escribe en
    // el fichero. Observar el uso de strlen en lugar de sizeof. 
    sprintf(linea, "%s\n", txt); write(f_texto, linea, strlen(linea));
    sprintf(linea, "%d\n", x);   write(f_texto, linea, strlen(linea));
    sprintf(linea, "%d\n", y);   write(f_texto, linea, strlen(linea));
    sprintf(linea, "%f\n", g);   write(f_texto, linea, strlen(linea));
    close(f_texto);
    
    // Ahora escribimos los mismos datos directamente en binario
    write(f_data, txt, 5); // La cadena tiene 4 letras mas terminador
    write(f_data, &x, sizeof(int)); 
    write(f_data, &y, sizeof(int));
    write(f_data, &g, sizeof(float));
    close(f_data);
    
    printf("Ficheros Datos.txt y Datos.dat creados\n");
    return 0;
  }
  else { // Si hay argumento, modo "leer ficheros"
    char buffer[200]; // Para leer el fichero .txt
    // El fichero no puede tener mas de 200 bytes
    int n_bytes_leidos;

    f_texto=open("Datos.txt", O_RDONLY|O_TEXT);
    if (f_texto==-1) {
      perror("Al abrir Datos.txt");  exit(-1);
    }
    f_data=open("Datos.dat", O_RDONLY|O_BINARY);
    if (f_texto==-1) {
      perror("Al abrir Datos.dat"); exit(-1);
    }
    
    // Leemos los datos ASCII de Datos.txt
    // Leemos todo el fichero en un buffer, y extraemos la informacion
    // de ese buffer usando sscanf.
    n_bytes_leidos=read(f_texto, buffer, 200);
    printf("Se han leido %d bytes del fichero Datos.txt\n",
	   n_bytes_leidos);
    close(f_texto);
    // Extraer datos del buffer, usando los tipos apropiados
    sscanf(buffer, "%s\n%d\n%d\n%f\n", txt, &x, &y, &g);

    printf("Datos leidos de Datos.txt\n");
    printf(" txt=%s\n", txt);
    printf(" x=%d\n", x);
    printf(" y=%d\n", y);
    printf(" g=%f\n", g);

    // Leer los datos binarios de Datos.dat es mas sencillo
    read(f_data, txt, 5);
    read(f_data, &x, sizeof(int));
    read(f_data, &y, sizeof(int));
    read(f_data, &g, sizeof(float));
    close(f_data);

    printf("Datos leidos de Datos.dat\n");
    printf(" txt=%s\n", txt);
    printf(" x=%d\n", x);
    printf(" y=%d\n", y);
    printf(" g=%f\n", g);
    return 0;
  }
  
}

  
